/*****************************************/
/* Stack Shield v0.4                     */
/* by Vendicator 1999                    */
/*****************************************/
/* File: stackshield.c                   */
/* Stack Shield file protection program  */
/*****************************************/

#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <unistd.h>

#include "globalretstack.h"

void usage(char *progname);
void parsefile(FILE *srcptr, FILE *destptr);
void doprolog(FILE *fileptr);
void doepilog(FILE *fileptr);
void domainprolog(FILE *fileptr);

int prologcount = 0;
int epilogcount = 0;

void usage(char *progname) {
  fprintf(stderr, "Usage: %s srcfile destfile\n", progname);
  fprintf(stderr, "Where:\n");
  fprintf(stderr, "srcfile is the input assembly file\n");
  fprintf(stderr, "destfile is the output assembly file\n");

  exit(EXIT_FAILURE);
}

void doprolog(FILE *fileptr) {
  char label[257];
  char *block;
  char *buffer;
  char *tmp;

  block=(char *)calloc(strlen(grsprolog)+256, 1);
  buffer=(char *)calloc(strlen(grsprolog)+256, 1);
  strncpy(block, grsprolog, strlen(grsprolog));

  prologcount++;
  label[256]='\0';

  while (tmp=strstr(block, ".LSHIELDPROLOG<PROLOGCOUNT>")) {
    strncpy(buffer, tmp, 256);
    snprintf(label, 256, ".LSHIELDPROLOG%d", prologcount);
    strncpy(tmp, label, strlen(label));
    strncpy(tmp+strlen(label), buffer+strlen(".LSHIELDPROLOG<PROLOGCOUNT>"),
      strlen(buffer+strlen(".LSHIELDPROLOG<PROLOGCOUNT>")));
    tmp[strlen(label)+strlen(buffer+strlen(".LSHIELDEPILOG<PROLOGCOUNT>"))]='\0';
  }
  fprintf(fileptr, "%s", block);
}

void doepilog(FILE *fileptr) {
  char label[257];
  char *block;
  char *buffer;
  char *tmp;

  block=(char *)calloc(strlen(grsepilog)+32, 1);
  buffer=(char *)calloc(strlen(grsepilog)+32, 1);
  strncpy(block, grsepilog, strlen(grsepilog));

  epilogcount++;
  label[256]='\0';

  while (tmp=strstr(block, ".LSHIELDEPILOG<EPILOGCOUNT>")) {
    strncpy(buffer, tmp, 256);
    snprintf(label, 256, ".LSHIELDEPILOG%d", epilogcount);
    strncpy(tmp, label, strlen(label));
    strncpy(tmp+strlen(label), buffer+strlen(".LSHIELDEPILOG<EPILOGCOUNT>"),
      strlen(buffer+strlen(".LSHIELDEPILOG<EPILOGCOUNT>")));
    tmp[strlen(label)+strlen(buffer+strlen(".LSHIELDEPILOG<EPILOGCOUNT>"))]='\0';
  }
  fprintf(fileptr, "%s", block);
}

void domainprolog(FILE *fileptr) {
  fprintf(fileptr, "%s", grsmainprolog);
}

void parsefile(FILE *srcptr, FILE *destptr) {
  char line[257];

  line[256]='\0';
  while (fgets(line, 257, srcptr)) {
    if (strstr(line, "pushl %ebp")) {
      fprintf(destptr, "%s", line);
      fgets(line, 257, srcptr);
      if (strstr(line, "movl %esp,%ebp")) {
        fprintf(destptr, "%s", line);
        doprolog(destptr);
      }
    }
    else if (strstr(line, "movl %ebp,%esp")) {
      fgets(line, 257, srcptr);
      if (strstr(line, "popl %ebp")) {
        fgets(line, 257, srcptr);
        if (strstr(line, "ret")) {
	  doepilog(destptr);
	  fprintf(destptr, "	%s\n", "movl %ebp,%esp");
	  fprintf(destptr, "	%s\n", "popl %ebp");
  	  fprintf(destptr, "	%s\n", "ret");
        }
      }
    }
    else if (strstr(line, "main:")) {
      fprintf(destptr, "%s", line);
      domainprolog(destptr);
    }
    else
    fprintf(destptr, "%s", line);
  }
}

int main(int argc, char **argv) {
  char srcfile[257];
  char destfile[257];
  FILE *srcptr, *destptr;

  if (argc < 3)
    usage(argv[0]);
  strncpy(srcfile, argv[1], 257);
  strncpy(destfile, argv[2], 257);
  srcfile[256]=destfile[256]='\0';

  if ((srcptr=fopen(srcfile, "r")) == NULL) {
    fprintf(stderr, "Error: cannot read %s\n", srcfile);
    exit(EXIT_FAILURE);
  }

  if ((destptr=fopen(destfile, "w")) == NULL) {
    fprintf(stderr, "Error: cannot create %s\n", destfile);
    exit(EXIT_FAILURE);
  }

  fprintf(destptr, "%s", grsheader);
  parsefile(srcptr, destptr);
  
  fclose(srcptr);
  fclose(destptr);

  exit(EXIT_SUCCESS);
}